/* ***********************************************************
 * This file was automatically generated on 2012-09-28.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#ifndef BRICKLET_GPS_H
#define BRICKLET_GPS_H

#include "ip_connection.h"

/**
 * \defgroup BrickletGPS GPS Bricklet
 */

/**
 * \ingroup BrickletGPS
 *
 * Device for receiving GPS position
 */
typedef Device GPS;

/**
 * \ingroup BrickletGPS
 *
 * 
 */
#define GPS_CALLBACK_COORDINATES 8

/**
 * \ingroup BrickletGPS
 *
 * 
 */
#define GPS_CALLBACK_STATUS 9

/**
 * \ingroup BrickletGPS
 *
 * Creates an object with the unique device ID \c uid. This object can then be
 * added to the IP connection.
 */
void gps_create(GPS *gps, const char *uid);

/**
 * \ingroup BrickletGPS
 *
 * 
 */
int gps_get_coordinates(GPS *gps, char *ret_ns, uint16_t ret_latitude[2], char *ret_ew, uint16_t ret_longitude[2], uint16_t *ret_pdop, uint16_t *ret_hdop, uint16_t *ret_vdop);

/**
 * \ingroup BrickletGPS
 *
 * 
 */
int gps_get_status(GPS *gps, uint8_t *ret_fix, uint8_t *ret_satellites_view, uint8_t *ret_satellites_used, uint16_t *ret_speed, uint16_t *ret_course, uint32_t *ret_date, uint32_t *ret_time, int16_t *ret_altitude, int16_t *ret_altitude_accuracy);

/**
 * \ingroup BrickletGPS
 *
 * 
 */
int gps_restart(GPS *gps, uint8_t restart_type);

/**
 * \ingroup BrickletGPS
 *
 * 
 */
int gps_set_coordinates_callback_period(GPS *gps, uint32_t period);

/**
 * \ingroup BrickletGPS
 *
 * Returns the period as set by {@link gps_set_coordinates_callback_period}.
 */
int gps_get_coordinates_callback_period(GPS *gps, uint32_t *ret_period);

/**
 * \ingroup BrickletGPS
 *
 * 
 */
int gps_set_status_callback_period(GPS *gps, uint32_t period);

/**
 * \ingroup BrickletGPS
 *
 * Returns the period as set by {@link gps_get_status_callback_period}.
 */
int gps_get_status_callback_period(GPS *gps, uint32_t *ret_period);

/**
 * \ingroup BrickletGPS
 *
 * Returns the name (including the hardware version), the firmware version
 * and the binding version of the device. The firmware and binding versions are
 * given in arrays of size 3 with the syntax [major, minor, revision].
 */
int gps_get_version(GPS *gps, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]);

/**
 * \ingroup BrickletGPS
 *
 * Registers a callback with ID \c id to the function \c callback.
 */
void gps_register_callback(GPS *gps, uint8_t id, void *callback);

#endif
