/* ***********************************************************
 * This file was automatically generated on 2012-10-01.      *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

#include "bricklet_industrial_digital_out_4.h"

#include <string.h>

#define FUNCTION_SET_VALUE 1
#define FUNCTION_GET_VALUE 2
#define FUNCTION_SET_MONOFLOP 3
#define FUNCTION_GET_MONOFLOP 4
#define FUNCTION_SET_GROUP 5
#define FUNCTION_GET_GROUP 6
#define FUNCTION_GET_AVAILABLE_FOR_GROUP 7


typedef void (*monoflop_done_func_t)(uint16_t, uint16_t);

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(push)
	#pragma pack(1)
	#define ATTRIBUTE_PACKED
#elif defined __GNUC__
	#define ATTRIBUTE_PACKED __attribute__((packed))
#else
	#error unknown compiler, do not know how to enable struct packing
#endif

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t value_mask;
} ATTRIBUTE_PACKED SetValue_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetValue_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t value_mask;
} ATTRIBUTE_PACKED GetValueReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t pin_mask;
	uint16_t value_mask;
	uint32_t time;
} ATTRIBUTE_PACKED SetMonoflop_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t pin;
} ATTRIBUTE_PACKED GetMonoflop_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t value;
	uint32_t time;
	uint32_t time_remaining;
} ATTRIBUTE_PACKED GetMonoflopReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char group[4];
} ATTRIBUTE_PACKED SetGroup_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetGroup_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	char group[4];
} ATTRIBUTE_PACKED GetGroupReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
} ATTRIBUTE_PACKED GetAvailableForGroup_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint8_t available;
} ATTRIBUTE_PACKED GetAvailableForGroupReturn_;

typedef struct {
	uint8_t stack_id;
	uint8_t function_id;
	uint16_t length;
	uint16_t pin_mask;
	uint16_t value_mask;
} ATTRIBUTE_PACKED MonoflopDoneCallback_;

#if defined _MSC_VER || defined __BORLANDC__
	#pragma pack(pop)
#endif
#undef ATTRIBUTE_PACKED

int industrial_digital_out_4_set_value(IndustrialDigitalOut4 *industrial_digital_out_4, uint16_t value_mask) {
	if(industrial_digital_out_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_out_4->write_mutex);

	SetValue_ sv;
	sv.stack_id = industrial_digital_out_4->stack_id;
	sv.function_id = FUNCTION_SET_VALUE;
	sv.length = ipcon_leconvert_uint16_to(sizeof(SetValue_));
	sv.value_mask = ipcon_leconvert_uint16_to(value_mask);

	ipcon_device_write(industrial_digital_out_4, (char *)&sv, sizeof(SetValue_));

	ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);

	return E_OK;
}

int industrial_digital_out_4_get_value(IndustrialDigitalOut4 *industrial_digital_out_4, uint16_t *ret_value_mask) {
	if(industrial_digital_out_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_out_4->write_mutex);

	industrial_digital_out_4->response.function_id = FUNCTION_GET_VALUE;
	industrial_digital_out_4->response.length = sizeof(GetValueReturn_);
	GetValue_ gv;
	gv.stack_id = industrial_digital_out_4->stack_id;
	gv.function_id = FUNCTION_GET_VALUE;
	gv.length = ipcon_leconvert_uint16_to(sizeof(GetValue_));

	ipcon_device_write(industrial_digital_out_4, (char *)&gv, sizeof(GetValue_));

	if(ipcon_device_expect_response(industrial_digital_out_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);
		return E_TIMEOUT;
	}

	GetValueReturn_ *gvr = (GetValueReturn_ *)industrial_digital_out_4->response.buffer;
	*ret_value_mask = ipcon_leconvert_uint16_from(gvr->value_mask);

	ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);

	return E_OK;
}

int industrial_digital_out_4_set_monoflop(IndustrialDigitalOut4 *industrial_digital_out_4, uint16_t pin_mask, uint16_t value_mask, uint32_t time) {
	if(industrial_digital_out_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_out_4->write_mutex);

	SetMonoflop_ sm;
	sm.stack_id = industrial_digital_out_4->stack_id;
	sm.function_id = FUNCTION_SET_MONOFLOP;
	sm.length = ipcon_leconvert_uint16_to(sizeof(SetMonoflop_));
	sm.pin_mask = ipcon_leconvert_uint16_to(pin_mask);
	sm.value_mask = ipcon_leconvert_uint16_to(value_mask);
	sm.time = ipcon_leconvert_uint32_to(time);

	ipcon_device_write(industrial_digital_out_4, (char *)&sm, sizeof(SetMonoflop_));

	ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);

	return E_OK;
}

int industrial_digital_out_4_get_monoflop(IndustrialDigitalOut4 *industrial_digital_out_4, uint8_t pin, uint16_t *ret_value, uint32_t *ret_time, uint32_t *ret_time_remaining) {
	if(industrial_digital_out_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_out_4->write_mutex);

	industrial_digital_out_4->response.function_id = FUNCTION_GET_MONOFLOP;
	industrial_digital_out_4->response.length = sizeof(GetMonoflopReturn_);
	GetMonoflop_ gm;
	gm.stack_id = industrial_digital_out_4->stack_id;
	gm.function_id = FUNCTION_GET_MONOFLOP;
	gm.length = ipcon_leconvert_uint16_to(sizeof(GetMonoflop_));
	gm.pin = pin;

	ipcon_device_write(industrial_digital_out_4, (char *)&gm, sizeof(GetMonoflop_));

	if(ipcon_device_expect_response(industrial_digital_out_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);
		return E_TIMEOUT;
	}

	GetMonoflopReturn_ *gmr = (GetMonoflopReturn_ *)industrial_digital_out_4->response.buffer;
	*ret_value = ipcon_leconvert_uint16_from(gmr->value);
	*ret_time = ipcon_leconvert_uint32_from(gmr->time);
	*ret_time_remaining = ipcon_leconvert_uint32_from(gmr->time_remaining);

	ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);

	return E_OK;
}

int industrial_digital_out_4_set_group(IndustrialDigitalOut4 *industrial_digital_out_4, char group[4]) {
	if(industrial_digital_out_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_out_4->write_mutex);

	SetGroup_ sg;
	sg.stack_id = industrial_digital_out_4->stack_id;
	sg.function_id = FUNCTION_SET_GROUP;
	sg.length = ipcon_leconvert_uint16_to(sizeof(SetGroup_));
	memcpy(sg.group, group, 4*sizeof(char));

	ipcon_device_write(industrial_digital_out_4, (char *)&sg, sizeof(SetGroup_));

	ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);

	return E_OK;
}

int industrial_digital_out_4_get_group(IndustrialDigitalOut4 *industrial_digital_out_4, char ret_group[4]) {
	if(industrial_digital_out_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_out_4->write_mutex);

	industrial_digital_out_4->response.function_id = FUNCTION_GET_GROUP;
	industrial_digital_out_4->response.length = sizeof(GetGroupReturn_);
	GetGroup_ gg;
	gg.stack_id = industrial_digital_out_4->stack_id;
	gg.function_id = FUNCTION_GET_GROUP;
	gg.length = ipcon_leconvert_uint16_to(sizeof(GetGroup_));

	ipcon_device_write(industrial_digital_out_4, (char *)&gg, sizeof(GetGroup_));

	if(ipcon_device_expect_response(industrial_digital_out_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);
		return E_TIMEOUT;
	}

	GetGroupReturn_ *ggr = (GetGroupReturn_ *)industrial_digital_out_4->response.buffer;
	memcpy(ret_group, ggr->group, 4*sizeof(char));

	ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);

	return E_OK;
}

int industrial_digital_out_4_get_available_for_group(IndustrialDigitalOut4 *industrial_digital_out_4, uint8_t *ret_available) {
	if(industrial_digital_out_4->ipcon == NULL) {
		return E_NOT_ADDED;
	}

	ipcon_mutex_lock(&industrial_digital_out_4->write_mutex);

	industrial_digital_out_4->response.function_id = FUNCTION_GET_AVAILABLE_FOR_GROUP;
	industrial_digital_out_4->response.length = sizeof(GetAvailableForGroupReturn_);
	GetAvailableForGroup_ gafg;
	gafg.stack_id = industrial_digital_out_4->stack_id;
	gafg.function_id = FUNCTION_GET_AVAILABLE_FOR_GROUP;
	gafg.length = ipcon_leconvert_uint16_to(sizeof(GetAvailableForGroup_));

	ipcon_device_write(industrial_digital_out_4, (char *)&gafg, sizeof(GetAvailableForGroup_));

	if(ipcon_device_expect_response(industrial_digital_out_4) != 0) {
		ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);
		return E_TIMEOUT;
	}

	GetAvailableForGroupReturn_ *gafgr = (GetAvailableForGroupReturn_ *)industrial_digital_out_4->response.buffer;
	*ret_available = gafgr->available;

	ipcon_mutex_unlock(&industrial_digital_out_4->write_mutex);

	return E_OK;
}

int industrial_digital_out_4_get_version(IndustrialDigitalOut4 *industrial_digital_out_4, char ret_name[40], uint8_t ret_firmware_version[3], uint8_t ret_binding_version[3]) {
	strncpy(ret_name, industrial_digital_out_4->name, 40);

	ret_firmware_version[0] = industrial_digital_out_4->firmware_version[0];
	ret_firmware_version[1] = industrial_digital_out_4->firmware_version[1];
	ret_firmware_version[2] = industrial_digital_out_4->firmware_version[2];

	ret_binding_version[0] = industrial_digital_out_4->binding_version[0];
	ret_binding_version[1] = industrial_digital_out_4->binding_version[1];
	ret_binding_version[2] = industrial_digital_out_4->binding_version[2];

	return E_OK;
}

static int industrial_digital_out_4_callback_wrapper_monoflop_done(IndustrialDigitalOut4 *industrial_digital_out_4, const unsigned char *buffer) {
	MonoflopDoneCallback_ *mdc = (MonoflopDoneCallback_ *)buffer;
	mdc->pin_mask = ipcon_leconvert_uint16_from(mdc->pin_mask);
	mdc->value_mask = ipcon_leconvert_uint16_from(mdc->value_mask);
	((monoflop_done_func_t)industrial_digital_out_4->registered_callbacks[mdc->function_id])(mdc->pin_mask, mdc->value_mask);
	return sizeof(MonoflopDoneCallback_);
}

void industrial_digital_out_4_register_callback(IndustrialDigitalOut4 *industrial_digital_out_4, uint8_t id, void *callback) {
	industrial_digital_out_4->registered_callbacks[id] = callback;
}

void industrial_digital_out_4_create(IndustrialDigitalOut4 *industrial_digital_out_4, const char *uid) {
	ipcon_device_create(industrial_digital_out_4, uid);

	industrial_digital_out_4->expected_name = "Industrial Digital Out 4 Bricklet";

	industrial_digital_out_4->binding_version[0] = 1;
	industrial_digital_out_4->binding_version[1] = 0;
	industrial_digital_out_4->binding_version[2] = 0;

	industrial_digital_out_4->callback_wrappers[INDUSTRIAL_DIGITAL_OUT_4_CALLBACK_MONOFLOP_DONE] = industrial_digital_out_4_callback_wrapper_monoflop_done;
}
